
scriptInstance <- null;

// Company class used to mainly to check if HQ is moved (company.hq)
class Company
{
	id = null;

	constructor(id) {
		this.id = id;
	}
}

// This is the main Class
class IntegerABC extends GSController
{
  data = null; //data to save
	scorelist = null;
	companies = null;
	current_month = 0;
	last_month = -1;
	cur_day = 0;
	last_day = -1;
	goal = null;
	goals = [];
	companies = [];
	last_date = 0;
	from_save = false;

	constructor()
	{
		scorelist = GSList();
	}

 	function Process();
	function GetCompanyByID(id);
}

// Start function, this is where it all begins
function IntegerABC::Start()
{
	this.Sleep(1);
	GSLog.Info("starting up!");
	
	this.goal = 256*256*256*256 - 100; //TEST
	GSLog.Info("Goal: target: " + this.goal);
	// day tick = 74
	local sleeptime = 74; // 31 ticks ~= 1 second,	 1 game day ~= 2,3s, 1 game month ~= 75s
	if(from_save == false){
		GSGoal.New(GSCompany.COMPANY_INVALID, GSText(GSText.STR_INTEGER1, this.goal, this.goal, this.goal), GSGoal.GT_NONE, 0);
	}
	
	while (true) {
		this.Process();
		this.Sleep(sleeptime);
	}
}

function IntegerABC::Save(){
	this.data = { sv_companies = [] };
	foreach(company in this.companies){
		this.data.sv_companies.append(company.id);
	}
	return this.data;
}

function IntegerABC::Load(version, tbl) {
	foreach(key, val in tbl)	{
		if(key == "sv_companies"){
			foreach(company in val){
				this.companies.append(Company(company));
			}
		}
	}
	this.from_save = true;
}

function IntegerABC::Process()
{
	this.current_month = GSDate.GetMonth(GSDate.GetCurrentDate());
	this.cur_day = GSDate.GetCurrentDate();
	if(this.cur_day == this.last_day) return;
	this.last_day = this.cur_day;
	CheckEvents();
}

function IntegerABC::CheckEvents()
{
	// General events
	while(GSEventController.IsEventWaiting()) {
		local event = GSEventController.GetNextEvent();
		if(event == null) continue;
		local eventType = event.GetEventType();
		if(eventType == GSEvent.ET_COMPANY_NEW) {
			// Done Logging the event to xShunter
			local newcompany = GSEventCompanyNew.Convert(event);
			companies.append( Company(newcompany.GetCompanyID()) );
			GSLog.Info("Found new company! " + newcompany.GetCompanyID());
		}
	}

	//clear goals to show new info
	for (local i = 0; i < goals.len(); i++) {
		GSGoal.Remove(goals[i]);
	}
	goals.clear();
	scorelist.Clear();

	foreach(company in companies) {
		if(company.id == GSCompany.COMPANY_INVALID) continue;
		local valint = GSCompany.GetQuarterlyCompanyValue(company.id, 0);
		GSLog.Info("Company value = " + valint);
		scorelist.AddItem(company.id, valint);
	}

	scorelist.Sort(GSList.SORT_BY_VALUE, GSList.SORT_DESCENDING);
	
	local rank = 1;
	foreach (companyid, score in scorelist) {
		local company = GetCompanyByID(companyid);
		local textobj = GSText(GSText.STR_INTEGER2, score, score, score);
		local goal_id = GSGoal.New(GSCompany.COMPANY_INVALID, textobj, GSGoal.GT_NONE, 0);
		goals.append(goal_id);
		rank++;
	}
	
}

function IntegerABC::GetCompanyByID(id){
	foreach(company in companies) {
		if(id == company.id) return company;
	}
}
